function y = square_waveshaping(x)
    y = zeros(size(x));
    N = length(x);
    m = 0;
    m0 = 0;
    lambda = 0.98;
    for k=1:N
       if abs(x(k)) > abs(m*lambda)
           m = x(k);
           m0 = m;
       else
           m = m*lambda;
       end
       y(k) = m0;
    end
    
    if(max(y) > 1)
        y = y / max(y);
    end
end